import type { RollTableDetailsAndResults, RollTableResultFull } from '../../common/rolltable';
import type { RerollEventDetail } from '../generator-entrypoint';

interface CustomEventMap {
	"resultselected": CustomEvent<RollTableResultFull<RollTableDetailsAndResults>>;
	"reroll": CustomEvent<RerollEventDetail>
}
declare global {
	interface HTMLElement {
		addEventListener<K extends keyof CustomEventMap>(type: K,
																										 listener: (this: Document, ev: CustomEventMap[K]) => void,
																										 options?: boolean|EventListenerOptions): void;
		dispatchEvent<K extends keyof CustomEventMap>(ev: CustomEventMap[K]): boolean;
		dispatchEvent<K extends keyof HTMLElementEventMap>(ev: HTMLElementEventMap[K]): boolean;
	}
}
