import { TableEmoji, TableHeaderDataset, tableIdentifier, type TableProps, TableTitle } from './TableHeader';
import { GeneratedResult, type GeneratedResultProps } from './GeneratedResult';

export type GeneratedElementProps = {
	table: TableProps
	selected: boolean|null
} & GeneratedResultProps

// TODO: reconstitute this
// TODO: get a callback for checkbox value changes

export function GeneratedElement(props: GeneratedElementProps) {
	const checkId = `selected-${tableIdentifier(props.table)}`
	return <li class="generatedElement" id={`generated-${tableIdentifier(props.table)}`}>
		<h2 class="generatedHead">
			<label
				class="generatedLabel tableHeader"
				{...(props.selected !== null ? {"for": checkId} : {})}
				{...TableHeaderDataset(props.table)}>
				<TableEmoji {...props.table} />
				{' '}
				<TableTitle {...props.table} />
			</label>
			{props.selected !== null
				? <input type="checkbox" class="generatedSelect" id={checkId} name={checkId} checked={props.selected} />
				: null}
		</h2>
		<GeneratedResult {...props} />
	</li>
}
